\documentclass[preprint]{sig-alternate}

%
% Other packages we need.x
%
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsmath}
\usepackage{latexsym}
\usepackage{graphics}
\usepackage{graphicx}
\usepackage{proof}
\usepackage{float}
\usepackage{fancyheadings}

%
% acmconf is not compatible with hyperref.
%
%\usepackage[backref]{hyperref}
\newcommand\hypertarget[2]{#2}
\newcommand\hyperlink[2]{#2}

\input{trdefs.tex}
\input{defs.tex}

% hack
\sloppy

\begin{document}

\title{Process Migration and Transactions Using a Novel Intermediate Language}
\subtitle{[Extended Abstract] \titlenote{A full version of this paper
is available as Caltech technical report
\texttt{\trnum}, at
\texttt{mojave.caltech.edu}.  This work was supported by the
ONR, grant N00014-01-1-0765; DARPA, grant F33615-98-C3613; and AFOSR,
grant F49620-01-1-0361.}}

% Some dummy text for the ``preprint'' version.
\toappearbox{Submitted to the 30th Annual ACM
   SIGPLAN - SIGACT Symposium on
   Principles of Programming Languages,
   New Orleans, LA.}

%
% You need the command \numberofauthors to handle the "boxing"
% and alignment of the authors under the title, and to add
% a section for authors number 4 through n.
%
% Up to the first three authors are aligned under the title;
% use the \alignauthor commands below to handle those names
% and affiliations. Add names, affiliations, addresses for
% additional authors as the argument to \additionalauthors;
% these will be set for you without further effort on your
% part as the last section in the body of your article BEFORE
% References or any Appendices.

\numberofauthors{1}
%
% You can go ahead and credit authors number 4+ here;
% their names will appear in a section called
% "Additional Authors" just before the Appendices
% (if there are any) or Bibliography (if there
% aren't)

% Put no more than the first THREE authors in the \author command
\author{
%
% The command \alignauthor (no curly braces needed) should
% precede each author name, affiliation/snail-mail address and
% e-mail address. Additionally, tag each line of
% affiliation/address with \affaddr, and tag the
% e-mail address with \email.
\alignauthor 
       Jason Hickey,
       Justin D. Smith,
       Brian Aydemir,\\
       Nathaniel Gray,
       Adam Granicz,
       Cristian Tapus\\
       \affaddr{Caltech Computer Science 256-80}\\
       \affaddr{Pasadena, CA 91125}\\
       \email{\{jyh,justins,emre,n8gray,granicz,crt\}@cs.caltech.edu}
}
% \additionalauthors{Additional authors: John Smith (The Th{\o}rv\"{a}ld Group,
% email: {\texttt{jsmith@affiliation.org}}) and Julius P.~Kumquat
% (The Kumquat Consortium, email: {\texttt{jpkumquat@consortium.net}}).}

\date{19 July 2002}
\maketitle
\begin{abstract}
Process migration and atomic transactions are essential tools for constructing
fault-tolerant distributed systems.  We present a new system that includes a
typed intermediate language and runtime implementation designed to support
these services.  The language is type-safe and general enough to support
front-ends for both type-safe and unsafe languages.  We include benchmarks for
programs written in ML and ANSI~C.
\end{abstract}

\input{introduction.tex}
\input{syntax.tex}
\input{judgments.tex}
\input{type-rules.tex}
\input{op-semantics.tex}
\input{preservation.tex}
\input{progress.tex}
\input{backend.tex}
\input{benchmarks.tex}

\bibliographystyle{plain}
\bibliography{metaprl}

\input{lemmas-wf.tex}
\input{lemmas-unique.tex}
\input{lemmas-subst.tex}

\end{document}
